
// Rez source file for TMON 3.0-specific resources

TYPE 'TMPL' {
  array ItemArray
    {
    pstring;
    literal longint;
    };
  };


TYPE 'EFNT' {
  integer; /* Font size */
  pstring[39]; /* Font name */
  };

TYPE 'Str#' {
  integer = $$CountOf(StringArray);
  array StringArray
    {
    cstring;
    };
  };

TYPE 'Str&' {
  integer = $$CountOf(StringArray);
  array StringArray
    {
    integer;
    cstring;
    };
  };


TYPE 'Res#' {
  integer = $$CountOf(TypeArray);
  array TypeArray
    {
    literal longint;	// Resource type
    integer = $$CountOf(IDArray);
    wide array IDArray
      {
      integer;		// Resource id
      };
    };
  };

TYPE 'RTy#' {
  integer = $$CountOf(TypeArray);
  array TypeArray
    {
    literal longint;	// Resource type
    byte procAll=$FF, proc68000=$01, proc68010=$02, proc68020f=$FC, proc68020=$04, proc68030=$08,
	proc68040=$10, proc68050=$20;
    bitstring[4] fpuAll=$F, fpuNone=$1, fpuNeeded=$E, fpu68881=$2, fpu68882=$4, fpu68040=$8;
    bitstring[4] mmuAll=$F, mmuNone=$1, mmuNeeded=$E, mmu68851=$2, mmu68030=$4, mmu68040=$8;
    byte worldAll=$FF, worldPlus=$1, worldIIb=$F, worldSE=$2, worldPortable=$4, worldIIf=$F8, worldII=$8, worldIIcif=$F0, worldIIci=$10;
    bitstring[4] sysAll=$F, sys6p=$1, sys7f=$E, sys7=$2;
    bitstring[4] qdAll=$F, qdBW=$1, qdColorf=$E, qdColor=$2, qd32Bitf=$C, qd32Bit=$4;
    bitstring[4] vmAll=$F, vmNone=$1, vmNeeded=$E, vm1=$2;
    bitstring[2] slotAll=$3, slotNone=$1, slotNeeded=$2;
    bitstring[10]=$3FF;
    fill bit[13];
    boolean nonrelocatable,relocatable;
    boolean mutable,immutable;
    boolean optional,required;
    integer = $$CountOf(IDArray);
    wide array IDArray
      {
      integer;		// Low resource id bound
      integer;		// High resource id bound
      };
    };
  };

TYPE 'Wrld' {
  fill word;
  integer = $$CountOf(GlobalArray);
  array GlobalArray
    {
    hex longint;	// Low address (inclusive)
    hex longint;	// High address (exclusive)
    };
  fill word;
  integer = $$CountOf(TrapArray);
  array TrapArray
    {
    hex integer;	// Low trap number (inclusive)
    hex integer;	// High trap number (inclusive)
    };
  };

TYPE 'SInf' {
  integer = $$CountOf(SlotInfoArray);
  array SlotInfoArray
    {
    fill bit[2];
    boolean noMajor=0, useMajor=1;
    boolean noMinor=0, useMinor=1;
    boolean overrideMajorLength=1;
    boolean overrideMajorBaseOS=1;
    boolean overrideMinorLength=1;
    boolean overrideMinorBaseOS=1;
    fill bit[4];
    bitstring[4];	// Category wildcards
    hex integer;	// Category
    hex integer;	// CType
    hex integer;	// DrvrSW
    hex integer;	// DrvrHW
    hex longint;	// minorBaseOS
    hex longint;	// minorLength
    hex longint;	// majorBaseOS
    hex longint;	// majorLength
    };
  };

TYPE 'VecW' {
  array [8]
    {
    binary byte;
    };
  };


		/**/
		/*		  */
		/*  Type Numbers  */
		/*		  */
		/**/

// MPW types
#define typeVoid	 0
#define typePString	 1
#define typeULongInt	 2
#define typeSLongInt	 3
#define typeExtended	 4
#define typeBoolean	 5
#define typeUShortInt	 6
#define typeSShortInt	 7
#define typeChar	 8
#define typeChar2	 9
#define typeUInteger	10
#define typeSInteger	11
#define typeSingle	12
#define typeDouble	13
#define typeExtended12	14
#define typeComp	15
#define typeCString	16
#define typeAString	17
// Fixed TMON types
#define typeByte	0x100
#define typeWord	0x101
#define typeLong	0x102
#define typeBinByte	0x103
#define typeBinWord	0x104
#define typeBinLong	0x105
#define typeOctByte	0x106
#define typeOctWord	0x107
#define typeOctLong	0x108
#define typeBlockHeader24 0x109
#define typeBlockHeader32 0x10A
// Variable types
#define typeDump	0x200
#define typeByteDump	0x201
#define typeWordDump	0x202
#define typeLongDump	0x203
#define typeCode	0x204
// Other numbers between 0 and 0x00000FFF are reserved.
// Numbers between 0x00001000 and 0x00FFFFFF are available for user definition.
#define typeNumberField	0x00FFFFFF
#define typePtrFieldO	24
#define typePtrFieldN	3
#define typePtr		(1<<typePtrFieldO)
#define typeHandle	(typePtr<<1)
#define typeCodePtr	(typePtr+typeCode)
#define typeStringPtr	(typePtr+typePString)
#define typeStringHandle (typeHandle+typePString)
// Numbers between 0x08000000 and 0xFFFFFFFF are reserved.


TYPE 'Typ#' {
  integer = $$CountOf(TypeArray);
  array TypeArray
    {
    binary longint;	// Type flags
    hex longint;	// Type size
    hex longint;	// Type number (0 if none)
    pstring;		// Type name
    align word;
    integer = $$CountOf(FieldArray);
    array FieldArray
      {
      binary integer;	// Field flags
      hex longint;	// Field offset
      hex longint;	// Field size
      hex longint;	// Field type
      pstring;		// Field name
      align word;
      };
    };
  };

TYPE 'RTyp' {
  integer = $$CountOf(ResTypeArray);
  array ResTypeArray
    {
    literal longint;	// Resource type
    fill bit[30];
    boolean;		// Is this a code type with a two-word segment loader preamble?
    boolean;		// Should this resource be scanned for embedded code labels?
    hex longint;	// Type number
    fill long;
    };
  };

TYPE 'Lbl#' {
  binary longint;	// Flags
  integer = $$CountOf(LabelArray);
  array LabelArray
    {
    hex longint;	// Low address
    hex longint;	// High address
    hex longint;	// Type
    pstring;		// Name
    align word;
    };
  };

TYPE 'A000' {
  integer = $$CountOf(NibbleArray);
  array NibbleArray
    {
    pstring; // Bit 10
    pstring; // Bit 9
    pstring; // Bit 8
    };
  integer = $$CountOf(TrapArray);
  array TrapArray
    {
    unsigned bitstring[4]; // NibbleArray index
    unsigned hex bitstring[12]; // Trap number
    pstring; // Trap name
    };
  };

TYPE 'Asm ' {
  integer = $$CountOf(MacroArray);
  array MacroArray
    {
    bitstring[4] nonA000=0, genericA000=1, selD0_W=2, selD0_L=3, selA0_W=4, selA0_L=5, selSP_W=6, selSP2_W=7, selSP_L=8;
    boolean;		// Allow nibble
    bitstring[3];	// Nibble bits mask
    byte = $$CountOf(WordArray)*2;
    wide array WordArray
      {
      unsigned hex integer; // Macro instructions
      };
    cstring;		// Macro name
    align word;
    };
  };

TYPE 'MDat' {
  literal longint;	// Signature of text files created by printing
  hex longint;		// Longword used for filling memory during heap scramble
  hex longint;		// Size of PlayMem block in system heap
  hex longint;		// Threshold heap size for memory warning cursor
  };


TYPE 'MSet' {
  byte;		// Major version
  byte;		// Minor version
  integer;	// Internal version
  pstring[255];	// Information
  byte bugPeace=0, bugWar=1;
  fill byte[3];
  hex longint;	// Data size
  hex longint;	// Stack size
  byte hiMem=0, sysHeap=1;
  byte noVectorWarning=0, vectorWarning=1;
  byte noVBLs=0, allowVBLs=1;
  byte noInitLoad=0, initLoad=1;
  byte normal=0, miser=1, custom1=2, custom2=3;
  fill byte[3];
  fill long[8];
  hex longint;	// Data size
  hex longint;	// Stack size
  byte hiMem=0, sysHeap=1;
  byte noVectorWarning=0, vectorWarning=1;
  byte noVBLs=0, allowVBLs=1;
  byte noInitLoad=0, initLoad=1;
  byte normal=0, miser=1, custom1=2, custom2=3;
  fill byte[3];
  fill long[8];
  };


TYPE 'UsrF' {
  integer famAll=$000F, famStd=$000D, famNormal=$0001, famMiser=$0002, famCustom1=$0004, famCustom2=$0008;
  byte=-1;
  byte procAll=$FF, proc68000=$01, proc68010=$02, proc68020f=$FC, proc68020=$04, proc68030=$08,
	proc68040=$10, proc68050=$20;
  longint=0;	// Unused; should be zero.
  };
